/**
* @author Dirk Nordmann
* @date   14.01.2002
*/
package util;

import java.io.*;
import java.util.*;

public class FilePathUtility
{

private static final String SEP = File.separator;

public FilePathUtility()
{
}

public static boolean exists(String s)
{
    File file = new File(s);
    return file.exists();
}
    
public static String SubstituteExtension(String s, String s1)
{
	int i = s.lastIndexOf(".");
	if(i > -1)
	{
		return s.substring(0, i) + s1;
	} else
	{
		System.out.println("Bad file name format (extension expected) " + s);
		return null;
	}
}



public static String findFile(String path, String filename, String extension)
{
	String rtn = null;
	File file = new File(path);
	if (file.exists())
	{
		if ((filename.equals("*") || filename.toLowerCase().equals(getFileName(file.getName().toLowerCase()))) && 
			(extension.equals("*") || extension.toLowerCase().equals(getFileExtension(file.getName().toLowerCase()))))
			return path;			
		// find recursive file
		File[] filelist = file.listFiles();	
		if (filelist != null)
		for (int i=0; i < filelist.length; i++)
		{
			rtn = findFile( path + SEP + filelist[i].getName(),filename,extension);
		    if (rtn != null)	
				break;
		}	
	}
	return rtn;
}



public static void removeDir(String path)
{
	File file = new File(path);
	if (file.exists())
	{
		// remove recursive file
		File[] filelist = file.listFiles();	
		if (filelist != null)
			for (int i=0; i < filelist.length; i++)
				removeDir( file.getName() + SEP + filelist[i].getName());
		// remove file	
		file.delete();
		while (file.exists());
	}
}
			
public static String getOSFileName(String s)
{
	String rtn = s;
	if (SEP.equals("/"))
		rtn = StringUtil.replace(rtn,"\\",SEP);
	else
	if (SEP.equals("\\"))
		rtn = StringUtil.replace(rtn,"/",SEP);
	return rtn;
}
	
	
	
    public static String getDirectory(String s)
    {
        String s1 = "";
        int i = s.lastIndexOf(SEP);
        if(i != -1)
            s1 = s.substring(0, i);
        return s1;
    }



    public static String getFileName(String s)
    {
        String s1 = s;
		int i;
        
		i = s.lastIndexOf('\\');
        if(i != -1)
            s1 = s.substring(i + 1);
        
		i = s.lastIndexOf('/');
        if(i != -1)
            s1 = s.substring(i + 1);
        
		i = s1.lastIndexOf(".");
        if(i != -1)
            s1 = s1.substring(0, i);
        
		return s1;
    }



    public static String getFileExtension(String s)
    {
        String s1 = s;
        int i = s.lastIndexOf(SEP);
        if(i != -1)
            s1 = s.substring(i + 1);
        i = s1.lastIndexOf(".");
        if(i != -1)
            s1 = s1.substring(i,s1.length());
        return s1;
    }
}
