###################################################################################################
# _metacmdmanager.py
#
# Implementation of class MetacmdManager (see below).
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###################################################################################################

# Imports.
from Globals import HTML, HTMLFile
import string
import urllib
import copy
# Product Imports.
import _globals
import _xmllib


###################################################################################################
###################################################################################################
###
###   class MetacmdManager
###
###################################################################################################
###################################################################################################
class MetacmdManager: 

    # Management Permissions.
    # -----------------------
    __authorPermissions__ = ()
    __editorPermissions__ = ()
    __administratorPermissions__ = (
		'manage_changeMetacmds','manage_customizeMetacmdForm',
		)
    __ac_permissions__=(
		('ZMS Administrator', __administratorPermissions__),
		('ZMS Author', __authorPermissions__),
		('ZMS Editor', __editorPermissions__),
		)


    # Management Interface to customize Meta-Functions.
    manage_customizeMetacmdForm = HTMLFile('dtml/metacmd/manage_customizeform', globals()) 


    # ------------------------------------------------------------------------------------------
    #  getMetaCmds
    # ------------------------------------------------------------------------------------------
    def getMetaCmds(self, REQUEST):
      if not hasattr(self,'__attr_dc_metacmds__'):
        self.__attr_dc_metacmds__ = []
      return getattr(self,'__attr_dc_metacmds__')
    

    ############################################################################################
    # MetacmdManager.manage_changeMetacmds:
    #
    # Chane Meta-Commands.
    ############################################################################################
    def manage_changeMetacmds(self, btn, lang, manage_lang, REQUEST, RESPONSE):
        """ MetacmdManager.manage_changeMetacmds """

        message = ''
        id = ''
    
        # Insert.
        # -------
        if btn == self.getLangStr('BTN_INSERT',manage_lang):
          # Catalog.
          meta_cmds = self.getMetaCmds(REQUEST)
          meta_cmd = {}
          meta_cmd['id'] = REQUEST['_id']
          meta_cmd['name'] = REQUEST['_name']
          meta_cmds.append(meta_cmd)
          self.__attr_dc_metacmds__ = meta_cmds
          # Object.
          id = REQUEST['_id']
          title = '*** DO NOT DELETE OR MODIFY ***'
          raw = ''
          self.manage_addDTMLMethod(id,title,raw)
            
        # Delete.
        # -------
        elif btn == self.getLangStr('BTN_DELETE',manage_lang):
          id = REQUEST['id']
          # Catalog.
          meta_cmds = self.getMetaCmds(REQUEST)
          for meta_cmd in meta_cmds:
            if meta_cmd['id']==id:
              meta_cmds.remove(meta_cmd)
          self.__attr_dc_metacmds__ = meta_cmds
          # Object.
          self.manage_delObjects(ids=[id])

        # Change.
        # -------
        elif btn == self.getLangStr('BTN_CHANGE',manage_lang):
          pass

        # Import.
        # -------
        elif btn == self.getLangStr('BTN_IMPORT',manage_lang):
          pass

        # Export.
        # -------
        elif btn == self.getLangStr('BTN_EXPORT',manage_lang):
          id = REQUEST['id']
          content_type = 'text/xml'
          filename = id + '.xml'
          export = '<?xml version="1.0" encoding="ISO-8859-1"?>'
          export = export + _xmllib.toXml({'key':id})
          RESPONSE.setHeader('Content-Type',content_type)
          RESPONSE.setHeader('Content-Disposition','inline;filename=%s'%filename)
          return export

        # Return with message.
        message = urllib.quote(message)
        return RESPONSE.redirect('manage_customizeMetacmdForm?lang=%s&manage_lang=%s&manage_tabs_message=%s&id=%s'%(lang,manage_lang,message,id))

###################################################################################################
